//+======================================================================================+
//|                                                                     i-RVI.mq4        |
//+======================================================================================+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 clrSkyBlue

//+======================================+
extern int RVIPeriod = 14;
double bBUF1[];
double bBUF2[];
double bBUF3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {

   IndicatorBuffers(3);
   SetIndexStyle(0, DRAW_LINE,0,2);
   SetIndexBuffer(0, bBUF1);
   SetIndexBuffer(1, bBUF2);
   SetIndexBuffer(2, bBUF3);
   //+-----------------+
   SetLevelValue(1,50.0);

   string Name_Ind = "Relative Volatility Index";
   IndicatorShortName(Name_Ind);
   SetIndexLabel(0, Name_Ind);
   SetIndexDrawBegin(0, RVIPeriod);
   return (0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   double vClose;
   double StDevAve1;
   double StDevAve2;
   double pStrDev;
   double Sum_StDev1;
   double Sum_StDev2;
   int    i = 0;
   
   int iCounted = IndicatorCounted();
   if (Bars <= RVIPeriod) return (0);
   if (iCounted < 1)  for (i = 1; i <= RVIPeriod; i++)  bBUF1[Bars - i] = 0.0;
   i = Bars - RVIPeriod - 1;
   if (iCounted >= RVIPeriod) i = Bars - iCounted - 1;

   while (i >= 0) {
      Sum_StDev1 = 0.0;
      Sum_StDev2 = 0.0;
      if (i == Bars - RVIPeriod - 1) {
         for (int zz = Bars - 2; zz >= i; zz--) {
              vClose  = Close[zz] - (Close[zz + 1]);
              pStrDev = iStdDev(NULL, 0, 10, 0, MODE_EMA, PRICE_CLOSE, zz);
              if (vClose > 0.0) Sum_StDev2 += pStrDev;
              else              Sum_StDev1 += pStrDev;
         }
         StDevAve2 = Sum_StDev2 / RVIPeriod;
         StDevAve1 = Sum_StDev1 / RVIPeriod;
      } else {
         vClose = Close[i] - (Close[i + 1]);
         pStrDev = iStdDev(NULL, 0, 10, 0, MODE_EMA, PRICE_CLOSE, i);
         if (vClose > 0.0) Sum_StDev2 = pStrDev;
         else Sum_StDev1 = pStrDev;
         StDevAve2 = ((bBUF2[i + 1]) * (RVIPeriod - 1) + Sum_StDev2) / RVIPeriod;
         StDevAve1 = ((bBUF3[i + 1]) * (RVIPeriod - 1) + Sum_StDev1) / RVIPeriod;
      }
      bBUF2[i] = StDevAve2;
      bBUF3[i] = StDevAve1;
      if (StDevAve1 == 0.0) bBUF1[i] = 0.0;
      else bBUF1[i] = 100 - 100.0 / (StDevAve2 / StDevAve1 + 1.0);
      i--;
   }
   return (0);
}
//+---------------------------------------------+
